local commandList = " /scout on : Enables the addon |n /scout off : Disables the add-on |n /scout mapEnable : Enables the mini-map coordinates |n /scout mapDisable : Disables the mini-map coordinates |n /scout Manual : Sets the reporting mode to manual |n /scout automatic : Sets the reporting mode to Automatic |n /scout semiAutomatic : Sets the reporting mode to SemiAutomatic |n /scout default : Sets Scout's setting to default |n /scout setpos,xPos,yPos : Sets the position of the current location frame |n /scout help : Shows this help message"
local cache = {};

function scout_initialize()
	-- List of commands
	SlashCmdList["SCOUT"] = scout_command;
	SLASH_SCOUT1 = "/scout"; -- used internally by the "Player_Target_Change" Event	
end	

function scout_command(msg)
	-- converts the msg to lowercase
	msg = string.lower(msg)
	-- this function traps the command receive and then execute the correspoding action	
	if(msg=="report" and scoutEnabled == true and scoutMode == "automatic") then 
		report_target();
	elseif(msg=="manualreport" and scoutEnabled == true and scoutMode == "manual") then 
		manual_report_target();
	elseif(msg=="manualreport" and scoutEnabled == true and scoutMode == "semiautomatic") then 
		manual_report_target();
	elseif(msg=="report" and scoutEnabled == true and scoutMode == "semiautomatic") then 
		report_target();
	elseif (msg=="off") then
		scoutEnabled = false;
	elseif (msg=="on") then
		scoutEnabled = true;
	elseif (msg=="mapenable") then
		mapEnabled = true;
	elseif (msg=="mapdisable") then
		mapEnabled = false;
		elseif (msg=="manual") then
		scoutMode = "manual";
	elseif (msg== "automatic") then
		scoutMode = "automatic";
	elseif (msg=="semiautomatic") then
		scoutMode = "semiautomatic";
	elseif (msg=="default") then
		scoutEnabled = true;
		mapEnabled = true;
		scoutMode = "semiautomatic";
		winPosX = 490;
		winPosY = -225;
	elseif (msg=="status") then
		
		local scoutState = "scoutenabled: nil"
		if (scoutEnabled == nil) then
			scoutState = "scoutenabled : nil";
		elseif scoutEnabled == true then
		  	scoutState = "scoutenabled : true";
		else
	  		scoutState = "scoutenabled : false";
		end
					
		local mapState = "mapenabled : nil"
		if (mapEnabled == nil) then
			mapState = "mapenabled : nil";
		elseif mapEnabled == true then
			mapState = "mapenabled : true";
		else
	  		mapState = "mapenabled : false";
		end
		
		local scoutModeState = "scoutmode : nil"
		if (scoutMode == nil) then
			scoutModeState = "scoutmode : nil";
		elseif scoutMode == "automatic" then
			scoutModeState = "scoutmode : automatic";
		elseif scoutMode == "manual" then
	  		scoutModeState = "scoutmode : manual";
	  	else
	  		scoutModeState = "scoutmode : semautomatic";
		  end		
		  DEFAULT_CHAT_FRAME:AddMessage("status : \n " .. scoutState .. "\n " .. mapState .. "\n " .. scoutModeState .. "\n " .. winPosX .. "\n " .. winPosY .. "\n");
    elseif (msg=="showcache") then
		  showCache();
	  elseif (msg=="help") then
		  DEFAULT_CHAT_FRAME:AddMessage(commandList);
	  else
		  -- Breaks down the command and the arguments
		  local argList = {};
		  for word in string.gmatch(msg..",", "(.-),") do
	    	table.insert(argList, word);
		end
		-- uses the arguments to set the values of the variable
		if argList[1] == "setpos" then
			winPosX = argList[2];
			winPosY = argList[3];
		end
	end
end

function get_target_info()
	-- this function will return the target's info
	local TargetRace = "";
	local TargetClass = "";
	local TargetLevel = "";
	local TargetClassification = "";
	local info = "";
	
    
   
    
	TargetName = UnitName("Target");
	TargetRace = UnitRace("Target");
	TargetClass = UnitClass("Target");
	TargetLevel = UnitLevel("Target");
	TargetClassification = UnitClassification("Target");

	PlayerLevel = 10 + UnitLevel("Player");
	
	if TargetLevel == -1 then
		TargetLevel = "??" .. " (" .. PlayerLevel .. "+)";
	end
	if UnitIsPlayer("Target") then
		if flagEnabled == true then
			info = TargetName .. ", " .. TargetRace .. " " .. TargetClass .. " " .. TargetLevel
		else
			info = TargetName .. ", " .. TargetRace .. " " .. TargetClass .. " " .. TargetLevel
		end		
	elseif UnitPlayerControlled("Target") then
		if flagEnabled == true then
			info = TargetName .. ", " .. TargetLevel .. " (Pet)";
		else
			info = TargetName .. ", " .. TargetLevel .. " (Pet)";
		end
	else
		info = TargetName .. ", " .. TargetLevel .. " (" .. TargetClassification .. " Mob)";
	end
			
	return info;
end


function returnPlayerPos()
	-- This function returns the player's current location in X, Y coordinates (0,0) beign top left
	local loc = " ";
	local px,py=GetPlayerMapPosition("Player");
	px=floor(px*1000)
	py=floor(py*1000)
	px=px/10
	py=py/10
	
	if px == 0 and py == 0 then
		loc = " - / - ";
	else
		loc = px .. " / " .. py;
	end	

	return loc;
end

function report_target()
	-- This function reports the target to the specified channel (local or world)
	local location = GetRealZoneText();
	local location2 = GetMinimapZoneText();
	local location3 = location;
	if location2 == "" then
		location2 = GetZoneText();
	else
		location2 = location2 .. " - " .. "(" .. location .. ")";
	end
		
  location3 = location2
	
	local target = UnitName("Target");

	if not target == nil then
		target = target .. " " .. location3;
	end
	local isInCache = getFromCache(target)
	
	if isInCache == false then
		local index = GetChannelName("LocalDefense".. " - " .. location);
		if not UnitIsFriend("Player","Target") and UnitIsPlayer("target") and UnitIsPVP("Target") then
			local info = get_target_info();
			local loc = returnPlayerPos();
			info = info  .. " Spotted near " .. location3 .. " at " .. loc;			
			SendChatMessage(info, "channel", this.language, index);
			local px,py=GetPlayerMapPosition("Player");
			putInCache (target);
		end
	end
end

function manual_report_target()
	-- This function reports the target to the specified channel (local or world)
	local location = GetRealZoneText();
	local location2 = GetMinimapZoneText();
	local location3 = location;
	
  if location2 == "" then
		location2 = GetZoneText();
	else
		location2 = location2 .. " - " .. "(" .. location .. ")";
	end
		
  location3 = location2
	local location3 = location;
	if not location == location2 then
		location3 = location .. " - " .. location2;
	end
	
	local index = GetChannelName("LocalDefense".. " - " .. location);
	local zone = GetRealZoneText() .. " - " .. tostring(GetSubZoneText());
  
	local target = UnitName("Target")
	if not (target == nil) then
		target = target .. " " .. location3;
  	local isInCache = getFromCache(target)
  	if isInCache == false then	
  		if not UnitIsFriend("Player","Target") then
  			local info = get_target_info();
  			local loc = returnPlayerPos();
  			info = info  .. " Spotted near " .. location3 .. " at " .. loc;
  			SendChatMessage(info, "channel", this.language, index);
  			putInCache (target);
  		end
  	end
	end
end


function getFromCache(target)
    -- this function add the target to the cache, in order to avoid spam
    local isIncache = false;
	  
    for i=1,table.getn(cache) do
   	  local v = cache[i];
   	  if v == target then
   	    DEFAULT_CHAT_FRAME:AddMessage(target ..  " is already in Cache");
        isIncache = true;
        break;
      end
	  end
  return isIncache;
end


function putInCache (target)
  i = table.getn(cache);
  i = i + 1;
	table.insert(cache,i,target);
end

function clearCache()
	cache= {};
end

function checkPvPStatus()
  local pvpType = GetZonePVPInfo();
	if (pvpType == "Sanctuary") then
	 local currentStatus = scoutEnabled; 
	 scoutEnabled = false;
	elseif ((pvpType == "hostile") or (pvpType == "contested")) or (pvptype == "Friendly") then
		scoutEnabled = currentStatus;
	end
end


function showCache()
	local cacheContent = "Cache : |r";
	local found = nil;
  for i=1,table.getn(cache) do
    cacheContent = cacheContent .. " [" .. cache[i] .. "]";
  end
	DEFAULT_CHAT_FRAME:AddMessage(cacheContent);
end